package {
    import flash.net.NetStream;
    import flash.net.NetConnection;
    import flash.net.SharedObject;
    import flash.display.Sprite;
    import flash.events.*;
    import flash.system.Security;
    import flash.system.SecurityPanel;
    import flash.media.SoundTransform;
    import flash.net.ObjectEncoding;

    [SWF(width="800",height="600",frameRate="24",backgroundColor="#ffffff")]    
    public class Ball extends Sprite{
	private var nc:NetConnection;
	private var ns:NetStream;
	private var dragging:Boolean = false;
	private var so:SharedObject;
	private var ball:Sprite;
	
	public function Ball(){
	    ball = new Sprite();
	    ball.graphics.beginFill(0xff8800);
	    ball.graphics.drawCircle(0,0,50);
	    ball.graphics.endFill();
	    ball.addEventListener(MouseEvent.MOUSE_DOWN,startMove);
	    ball.addEventListener(MouseEvent.MOUSE_UP,stopMove);
	    addChild(ball);
	    nc = new NetConnection();
	    nc.client = new CustomClient();
	    nc.objectEncoding = ObjectEncoding.AMF0;
	    nc.connect("rtmp://localhost/oflaDemo");
	    nc.addEventListener(NetStatusEvent.NET_STATUS,onNetStatus);
	    nc.addEventListener(SecurityErrorEvent.SECURITY_ERROR,onSecurityError);
	    ball.addEventListener(MouseEvent.MOUSE_DOWN,startMove);
	    ball.addEventListener(MouseEvent.MOUSE_UP,stopMove);
	    ball.addEventListener(MouseEvent.MOUSE_MOVE,onMouseMove);
	}
	
	private function onNetStatus(evt:NetStatusEvent):void {
	    trace(evt.info.code);
	    switch(evt.info.code) {
	    case "NetConnection.Connect.Success":
		so = SharedObject.getRemote("ball", nc.uri, false);
		if( so ){
		    so.addEventListener( SyncEvent.SYNC ,function( evt:SyncEvent ):void{
			    if( evt.target.data["ballPosition"]){
				ball.x = so.data.ballPosition.x;
				ball.y = so.data.ballPosition.y;
			    }
			    so.setProperty("ballPosition", {x: ball.x, y: ball.y} );
			});
		    so.connect(nc);
		}
		break;
	    case "NetConnection.Connect.Closed":
		break;
	    case "NetConnection.Connect.Failed":
		break;
	    case "NetConnection.Connect.Rejected":
		break;
            default:
	    }
	}
	private function onSecurityError(evt:SecurityErrorEvent):void {
	}
	
	private function startMove(ev:Event):void{
	    dragging = true;
	    ball.startDrag();
	}
	private function stopMove(ev:Event):void{
	    dragging = false;
	    ball.stopDrag();
	}
	private function onMouseMove(evt:Event):void{
	    if( dragging == true ){
		so.setProperty("ballPosition", {x: ball.x, y: ball.y} );
	    }
	}
    }
}

class CustomClient {
    public function onBWDone():void {
	trace("onBWDone");
    }
    
    public function onMetaData(infoObj:Object):void {
	trace("onMetaData");
    }

    public function onPlayStatus(infoObj:Object):void {
			trace("playStatus");
    }
}